Attribute VB_Name = "WebApis"
'*********************************************************************
'/* COPYRIGHTS:                                                      */
'/*                                                                  */
'/*   This module contains code made available by IBM Corporation on */
'/* an AS IS basis.  Any one receiving the module is  considered  to */
'/* be  licensed under IBM copyrights to use the IBM-provided source */
'/* code in any way he or  she  deems  fit,  including  copying  it, */
'/* compiling  it,  modifying  it,  and  redistributing  it, with or */
'/* without modifications.  No license  under  any  IBM  patents  or */
'/* patent  applications  is  to  be  implied  from  this  copyright */
'/* license.                                                         */
'/*                                                                  */
'/*   A user of the module should understand that IBM cannot provide */
'/* technical support for the module and will not be responsible for */
'/* any consequences of use of the program.                          */
'/*                                                                  */
'/*   Any notice,  including this one, are not to  be  removed  from */
'/* the module with out the prior written consent of IBM.            */
'/*                                                                  */
'*********************************************************************
Option Explicit

'**********************************************************************
'WebApis
'     Exports:
'           DisplayURL - Display given URL with default browser
'**********************************************************************


'************* Windows APIS  *****************************************
Declare Function ShellExecute Lib "shell32.dll" Alias _
                     "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As _
                     String, ByVal lpFile As String, ByVal lpParameters As String, _
                     ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Declare Function GetDesktopWindow Lib "user32" () As Long


Public Sub DisplayURL(URL As String, Optional MsgBoxTitle As Variant)
'Rather then search for the installed browser, this launches
'the default browser associated with URL links.
'Both Netscape and IE like to register themselves for .URL files

   #If Win32 Then
      Dim rc As Long
      Dim hwndApp As Long
   #ElseIf Win16 Then
      Dim rc As Integer
      Dim hwndApp As Integer
   #End If

'On Error Resume Next
Const SW_SHOWNORMAL = 1
Dim I As Integer


   hwndApp = GetDesktopWindow()
   'ERROR_NO_ASSOCIATION  31 win16 and win32
   'For Win 16, other error values are:
   'Error Meaning 0  System was out of memory or executable file was corrupt.
   '2  The file was not found.
   '3  The path was not found.
   '5  Attempt was made to link to a task dynamically, or there was a sharing
   '6  Library required separate data segments for each task.
   '8  There was insufficient memory to start the application.
   '10 The Windows version was incorrect.
   '11 The executable file was invalid. Either it was not a Windows-based
   '12 Application was designed for a different operating system.
   '13 Application was designed for MS-DOS version 4.0.
   '14 Type of executable file was unknown.
   '20 Dynamic-link library (DLL) file was invalid. One of the DLLs required to
   '21 Application requires Microsoft Windows 32-bit extensions.
   
   'For Win 32, the error values are
   'Error Meaning 0  System was out of memory or executable file was corrupt.
   '2  The specified file was not found.
   '3  The specified path was not found.
   '11 The .EXE file is invalid (non-Win32 .EXE or error in the .EXE image)
   '26 A sharing violation occurred.
   '27 The filename association is incomplete or invalid.
   '31 There is no application associated with the given filename extension.
   
   rc = ShellExecute(hwndApp, "Open", URL, "", "c:\", _
                          SW_SHOWNORMAL%)
   Select Case rc
   Case 0
      MsgBox "Not enough memory to load web browser", 0, MsgBoxTitle
   Case 2
      MsgBox "Unable to locate URL shortcut", 0, MsgBoxTitle
   Case 31
      MsgBox "Unable to locate web browser.", 0, MsgBoxTitle
   Case Is > 32   ' Valid handle so it worked
   Case Else   ' Other values
      MsgBox "Error attempting to start web browser.  Return Code: " & Str(rc), _
               0, MsgBoxTitle
   End Select
   
End Sub



